-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib
local t,s
lib.classes["HUNTER"] = {}
lib.classes["HUNTER"][1] = function ()
	lib.AddSpell("CS",{77767},nil,nil,-14) -- Cobra Shot
	lib.AddAura("FF",82692,"buff","player") -- Focus Fire
	lib.AddSpell("FF",{82692}) -- Focus Fire
	lib.AddSpell("KC",{34026},nil,true) -- Kill Command
	lib.AddSpell("KS",{53351}) -- Kill Shot
	lib.AddAura("Frenzy",19615,"buff","player") -- Frenzy
	lib.AddSpell("BW",{19574}) -- Bestial Wrath
	lib.AddAura("BW",19574,"buff","player") -- Bestial Wrath
	lib.AddSpell("MS",{2643}) -- Multi-Shot
	lib.AddAura("BC",118455,"buff","pet") -- Beast Cleave
	
	lib.SetAuraFunction("BW","OnApply",function()
		lib.SetSpellCost("AS",30/2-lib.IsAura({"Thrill"})*20)
		lib.SetSpellCost("MS",40/2-lib.IsAura({"Thrill"})*20)
		lib.SetSpellCost("Barrage",60/2)
	end)
	
	lib.SetAuraFunction("BW","OnFade",function() 	
		lib.SetSpellCost("AS",30-lib.IsAura({"Thrill"})*20)
		lib.SetSpellCost("MS",40-lib.IsAura({"Thrill"})*20)
		lib.SetSpellCost("Barrage",nil)
	end)
	
	lib.SetAuraFunction("Thrill","OnApply",function()
		lib.SetSpellCost("AS",30/(1+lib.IsAura({"BW"}))-20)
		lib.SetSpellCost("MS",40/(1+lib.IsAura({"BW"}))-20)
	end)
	
	lib.SetAuraFunction("Thrill","OnFade",function() 	
		lib.SetSpellCost("AS",30/(1+lib.IsAura({"BW"})))
		lib.SetSpellCost("MS",40/(1+lib.IsAura({"BW"})))
	end)
	
	
	lib.AddAura("SF",177668,"buff","player") -- Steady Focus
	
				

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Stampede_buff")
	table.insert(cfg.plistdps,"BW_FF")
	table.insert(cfg.plistdps,"FF_Frenzy")
	
	table.insert(cfg.plistdps,"KC")
	table.insert(cfg.plistdps,"KS")
	if IsPlayerSpell(177667) then
		table.insert(cfg.plistdps,"CS_SF")
	end
	table.insert(cfg.plistdps,"Barrage")
--	table.insert(cfg.plistdps,"AS")
	table.insert(cfg.plistdps,"AS_thrill")
	table.insert(cfg.plistdps,"AS_focus")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"BW_FF")
	table.insert(cfg.plistaoe,"FF_Frenzy")
	table.insert(cfg.plistaoe,"MS_BC")
	table.insert(cfg.plistaoe,"Barrage")
	if IsPlayerSpell(177667) then
		table.insert(cfg.plistaoe,"CS_SF")
	end
	table.insert(cfg.plistaoe,"KC")
	table.insert(cfg.plistaoe,"KS")
	--table.insert(cfg.plistaoe,"trap")
	table.insert(cfg.plistaoe,"MS_focus")
	table.insert(cfg.plistaoe,"CS")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps
	
	cfg.case = {}
	cfg.case = {
		["CS_SF"] = function()
			if lib.IsLastSpell("CS") then
				if not lib.SpellCasting("CS") then
					return lib.SimpleCDCheck("CS",lib.GetAura({"SF"})-lib.GetSpellCT("CS"))
				end
			else
				if lib.SpellCasting("CS") then
					return lib.SimpleCDCheck("CS",lib.GetAura({"SF"})-lib.GetSpellCT("CS"))
				end
			end
			return nil
		end,
		["MS_BC"] = function()
			return lib.SimpleCDCheck("MS",lib.GetAura({"BC"}))
		end,
		["CS"] = function()
			if cfg.power>=cfg.powermax then return nil end
			return lib.SimpleCDCheck("CS")
		end,
		["Stampede_buff"] = function()
			if lib.GetAuras("Heroism")>lib.GetSpellCD("Stampede") or lib.GetAura({"FF"})>lib.GetSpellCD("Stampede") then
				return lib.SimpleCDCheck("Stampede")
			end
			return nil
		end,
		["FF_Frenzy"] = function()
			if lib.GetAuraNum("Frenzy")==5 then return lib.SimpleCDCheck("FF",lib.GetAura({"FF"})-6) end
			return nil
		end,
		["BW_FF"] = function()
			if lib.GetAura({"FF"})>lib.GetSpellCD("BW") then
				return lib.SimpleCDCheck("BW")
			end
			--if lib.hardtarget() then return lib.SimpleCDCheck("BW",hedlib.GetMax(lib.GetAura({"BW"})-3,lib.Time2Energy(30))) end
			return nil
		end,
		["AS_focus"] = function()
			if cfg.power > 75 or lib.KnownSpell("FS") then
				return lib.SimpleCDCheck("AS")
			end
			return nil
		end,
		["MS_focus"] = function()
			if cfg.power > 75 or lib.KnownSpell("FS") then
				return lib.SimpleCDCheck("MS")
			end
			return nil
		end,
		["AS_thrill"] = function()
			if (lib.GetAura({"Thrill"}) > lib.GetSpellCD("AS") and cfg.power > 35) or lib.GetAura({"BW"}) > lib.GetSpellCD("AS") then
				return lib.SimpleCDCheck("AS")
			end
			return nil
		end,
		
	}
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	cfg.spells_aoe={"MS"}
	cfg.spells_single={"AS"}
	return true
end

lib.classes["HUNTER"][2] = function ()
	lib.AddSpell("KS",{157708,53351}) -- Kill Shot
	lib.AddSpell("AS",{3044}) -- Arcane Shot
	lib.AddSpell("SS",{56641}) -- Steady Shot	
	
	cfg.spells["SS"].powerCost_real=-14
--	lib.AddSpell("Sting",{1978}) -- Serpent Sting
--	lib.AddSpell("Mark",{1130}) -- Hunter's Mark
	lib.AddSpell("CS",{53209}) -- Chimera Shot
	lib.AddSpell("AI",{19434}) -- Aimed Shot
--	lib.AddSpell("AI!",{82928},nil,true) -- Aimed Shot!
	
	
--	lib.AddSpell("KC",{34026}) -- Kill Command
	
	lib.AddSpell("MS",{2643}) -- Multi-Shot
	
--	lib.AddSpell("trap",{77769}) -- Trap Launcher
	lib.AddSpell("ET",{13813}) -- Explosive Trap
	lib.AddSpell("RF",{3045}) -- Rapid Fire
--	lib.AddSpell("Rs",{23989}) -- Readiness
	
--	lib.AddAura("MMM",82925,"buff","player") -- Ready, Set, Aim...
--	lib.AddAura("Fire",82926,"buff","player") -- Fire!
	lib.AddAura("ISS",53220,"buff","player") -- Improved Steady Shot
--	lib.AddAura("RiF",82897,"buff","player") -- Resistance is Futile!
--	lib.AddAura("Sting",1978,"debuff","target") -- Serpent Sting
	
--	lib.AddAuras("Mark",{1130,88691},"debuff","target") -- Hunter's Mark
--	lib.AddAuras("Speed",{3045,32182,80353,90355,49016,92124,92349},"buff","player")
		
	cfg.plistdps = {}
--	table.insert(cfg.plistdps,"Mark_noMark")
--	table.insert(cfg.plistdps,"Sting_noSting")
	table.insert(cfg.plistdps,"Crows")
	table.insert(cfg.plistdps,"RF")
	table.insert(cfg.plistdps,"CS")
--	table.insert(cfg.plistdps,"Rs")
--	table.insert(cfg.plistdps,"KS")
--	table.insert(cfg.plistdps,"SS_noISS")
--	table.insert(cfg.plistdps,"AI!")
--	table.insert(cfg.plistdps,"AI_Fire")
--	table.insert(cfg.plistdps,"AS_focus")
	table.insert(cfg.plistdps,"AI")
	table.insert(cfg.plistdps,"GT")
--	table.insert(cfg.plistdps,"CS_SrS")
--	table.insert(cfg.plistdps,"KC_RiF")
	table.insert(cfg.plistdps,"KS")
	table.insert(cfg.plistdps,"SS")
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ET")
	table.insert(cfg.plistaoe,"MS")
	table.insert(cfg.plistaoe,"KS")
--	table.insert(cfg.plistaoe,"AI_Fire")
	
	table.insert(cfg.plistaoe,"SS")
	

	cfg.plist = cfg.plistdps
	local ca=90 --90
	local ai_cast=1.8
	cfg.case = {}
	cfg.case = {
		["RF"] = function()
			if cfg.target=="worldboss"  then
				return lib.SimpleCDCheck("RF")
			end
			return nil
		end,
		["Rs"] = function()
			if lib.GetSpellCD("RF")>3 and cfg.target=="worldboss" and lib.GetSpellCD("CS")>lib.GetSpellCD(cfg.gcd) then
				return lib.SimpleCDCheck("Rs")
			end
			return nil
		end,
		["AI_90"] = function()
			if cfg.target=="worldboss" then
				if cfg.health>ca then
					return lib.EnergyCDCheck("AI")
				else
					if lib.GetSpellCT("AI")<=ai_cast then
						return lib.EnergyCDCheck("AI",nil,"CS")
					end
				end
			end
			return nil
		end,
		["AS_focus"] = function()
			if (lib.GetSpellCT("AI")>ai_cast and cfg.health<=ca) or cfg.target~="worldboss" then
				return lib.EnergyCDCheck("AS",nil,"CS")
			end
			return nil
		end,
		["SS_noISS"] = function()
			if lib.GetAura({"ISS"})<= (2*lib.GetSpellCT("SS")+1+lib.GetSpellCD(cfg.gcd)) then
				if lib.GetLastSpell({"SS"}) and lib.GetLast2Spell({"SS"}) then
					return nil
				end
				
				if not lib.GetLastSpell({"SS"}) then
					if not lib.SpellCasting("SS") then
						return lib.SimpleCDCheck("SS")
					elseif lib.GetAura({"ISS"})<= (lib.SpellCastingLeft()+lib.GetSpellCT("SS")+1) then
						return lib.SimpleCDCheck("SS")
					end
				else
					if not lib.SpellCasting("SS") then
						return lib.SimpleCDCheck("SS")
					end
				end
			end
			return nil
		end,
		["CS"] = function()
			return lib.EnergyCDCheck("CS")
		end,
		["AI"] = function()
			return lib.EnergyCDCheck("AI")
		end,
		["Mark_noMark"] = function()
			if not lib.GetLastSpell({"Mark"}) and cfg.target~="normal" then
				return lib.SimpleCDCheck("Mark",lib.GetAuras("Mark"))
			end
			return nil
		end,
	
		["KC_RiF"] = function()
			if lib.GetAura({"RiF"})>0 then
				return lib.SimpleCDCheck("KC")
			end
			return nil
		end,
		
		["CS_SrS"] = function()
			if lib.GetAura({"SrS"})<5 then
				return lib.SimpleCDCheck("CS")
			end
			return nil
		end
	}

	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	
	cfg.spells_aoe={"ET","MS"}
	cfg.spells_single={"AS","CS"}
	return true
end

lib.classes["HUNTER"][3] = function ()
	cfg.startaoe=2
	lib.AddSpell("CS",{77767,56641},nil,nil,-14) -- Cobra Shot	
	lib.AddSpell("FS",{152245},nil,nil,-50) -- Focusing Shot
	lib.AddSpell("ES",{53301},nil,true) -- Explosive Shot
	lib.AddSpell("BA",{3674},nil,true) -- Black Arrow
	
	lib.AddSpell("AS",{3044},nil,true) -- Arcane Shot
	lib.AddSpell("MS",{2643},nil,true) -- Multi-Shot
	
	lib.SetAuraFunction("Thrill","OnApply",function()
		lib.SetSpellCost("AS",30-20)
		lib.SetSpellCost("MS",40-20)
	end)
	lib.SetAuraFunction("Thrill","OnFade",function() 	
		lib.SetSpellCost("AS",30)
		lib.SetSpellCost("MS",40)
	end)
	
	lib.AddSpell("ET",{13813}) -- Explosive Trap
	lib.AddAura("ES",53301,"debuff","target") -- Explosive Shot
	lib.AddAura("LNL",168980,"buff","player") -- Lock and Load
	lib.SetAuraFunction("LNL","OnApply",function()
		lib.SetSpellCost("ES",0)
	end)
	lib.SetAuraFunction("LNL","OnFade",function()
		lib.SetSpellCost("ES",nil)
	end)
	cfg.TrackDOT="Sting"
	
	cfg.plistdps = {}	
	table.insert(cfg.plistdps,"BA")
	table.insert(cfg.plistdps,"ES")
	table.insert(cfg.plistdps,"Crows")
	table.insert(cfg.plistdps,"AS_noSting")
	table.insert(cfg.plistdps,"AS_thrill")
	table.insert(cfg.plistdps,"Barrage")
	--table.insert(cfg.plistdps,"ET")
	table.insert(cfg.plistdps,"AS_focus")
	table.insert(cfg.plistdps,"FS")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ES_LNL")
	table.insert(cfg.plistaoe,"ET")
	table.insert(cfg.plistaoe,"Barrage")
	table.insert(cfg.plistaoe,"MS")
	table.insert(cfg.plistaoe,"FS")
	table.insert(cfg.plistaoe,"CS")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Barrage2"] = function()
			if cfg.TotalTargets>=2 then
				return lib.SimpleCDCheck("Barrage")
			end
			return nil
		end,
		["AS_focus"] = function()
			if cfg.power > 70 or lib.KnownSpell("FS") then
				if cfg.TotalTargets>=cfg.startaoe then
					return lib.SimpleCDCheck("MS")
				else
					return lib.SimpleCDCheck("AS")
				end
			end
			return nil
		end,
		["AS_thrill"] = function()
			if lib.GetAura({"Thrill"}) > 0 and cfg.power > 35 then
				if cfg.TotalTargets>=cfg.startaoe then
					return lib.SimpleCDCheck("MS")
				else
					return lib.SimpleCDCheck("AS")
				end
			end
			return nil
		end,
		["AS_noSting"] = function()
			if cfg.TotalTargets>=cfg.startaoe then
				return lib.SimpleCDCheck("MS",lib.GetAura({"Sting"})-4.5)
			else
				return lib.SimpleCDCheck("AS",lib.GetAura({"Sting"})-4.5)
			end
			return nil
		end
	}

	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	--cfg.spells_aoe={"MS"}
	cfg.spells_single={"AS"}
	
	return true
end

lib.classevents["HUNTER"] = function()
	cfg.powertype="FOCUS"
	lib.AddSpell("Crows",{131894},nil,true) -- A Murder of Crows
	lib.AddSpell("Stampede",{121818}) -- Stampede
	lib.AddSpell("Barrage",{120360},nil,true) -- Barrage
	lib.AddSpell("GT",{117050},nil,true) -- Glaive Toss
	lib.AddAura("Sting",118253,"debuff","target") -- Serpent Sting
	--lib.AddSpell("Sting",{1978}) -- Serpent Sting
	lib.AddSpell("Dismiss",{2641}) -- Dismiss Pet
	cfg.gcd="Dismiss"
	lib.AddSpell("AS",{3044},nil,true) -- Arcane Shot
	lib.AddAura("Thrill",34720,"buff","player") -- Thrill of the Hunt

	
	function Heddclassevents.UNIT_POWER_FREQUENT(unit,powerType)
		if unit=="player" and powerType==cfg.powertype then
			lib.UpdateAllSpells()
		end
	end
	
	lib.rangecheck=function()
		if lib.inrange("AS") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	cfg.onpower=true
end